Option Strict On
Imports System.IO

Public Class frmMain
    Inherits System.Windows.Forms.Form

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents MainMenu1 As System.Windows.Forms.MainMenu
    Friend WithEvents mnuFile As System.Windows.Forms.MenuItem
    Friend WithEvents mnuFileOpen As System.Windows.Forms.MenuItem
    Friend WithEvents mnuFileSave As System.Windows.Forms.MenuItem
    Friend WithEvents mnuFileSaveAs As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItem5 As System.Windows.Forms.MenuItem
    Friend WithEvents mnuExit As System.Windows.Forms.MenuItem
    Friend WithEvents mnuHelp As System.Windows.Forms.MenuItem
    Friend WithEvents mnuHelpAbout As System.Windows.Forms.MenuItem
    Friend WithEvents mnuFileNew As System.Windows.Forms.MenuItem
    Friend WithEvents txtDocument As System.Windows.Forms.TextBox
    Friend WithEvents ofdOpenFile As System.Windows.Forms.OpenFileDialog
    Friend WithEvents sfdSaveFile As System.Windows.Forms.SaveFileDialog
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.components = New System.ComponentModel.Container
        Me.MainMenu1 = New System.Windows.Forms.MainMenu(Me.components)
        Me.mnuFile = New System.Windows.Forms.MenuItem
        Me.mnuFileNew = New System.Windows.Forms.MenuItem
        Me.mnuFileOpen = New System.Windows.Forms.MenuItem
        Me.mnuFileSave = New System.Windows.Forms.MenuItem
        Me.mnuFileSaveAs = New System.Windows.Forms.MenuItem
        Me.MenuItem5 = New System.Windows.Forms.MenuItem
        Me.mnuExit = New System.Windows.Forms.MenuItem
        Me.mnuHelp = New System.Windows.Forms.MenuItem
        Me.mnuHelpAbout = New System.Windows.Forms.MenuItem
        Me.txtDocument = New System.Windows.Forms.TextBox
        Me.ofdOpenFile = New System.Windows.Forms.OpenFileDialog
        Me.sfdSaveFile = New System.Windows.Forms.SaveFileDialog
        Me.SuspendLayout()
        '
        'MainMenu1
        '
        Me.MainMenu1.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.mnuFile, Me.mnuHelp})
        '
        'mnuFile
        '
        Me.mnuFile.Index = 0
        Me.mnuFile.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.mnuFileNew, Me.mnuFileOpen, Me.mnuFileSave, Me.mnuFileSaveAs, Me.MenuItem5, Me.mnuExit})
        Me.mnuFile.Text = "&File"
        '
        'mnuFileNew
        '
        Me.mnuFileNew.Index = 0
        Me.mnuFileNew.Shortcut = System.Windows.Forms.Shortcut.CtrlN
        Me.mnuFileNew.Text = "&New..."
        '
        'mnuFileOpen
        '
        Me.mnuFileOpen.Index = 1
        Me.mnuFileOpen.Shortcut = System.Windows.Forms.Shortcut.CtrlO
        Me.mnuFileOpen.Text = "&Open..."
        '
        'mnuFileSave
        '
        Me.mnuFileSave.Index = 2
        Me.mnuFileSave.Shortcut = System.Windows.Forms.Shortcut.CtrlS
        Me.mnuFileSave.Text = "&Save"
        '
        'mnuFileSaveAs
        '
        Me.mnuFileSaveAs.Index = 3
        Me.mnuFileSaveAs.Text = "Save &As..."
        '
        'MenuItem5
        '
        Me.MenuItem5.Index = 4
        Me.MenuItem5.Text = "-"
        '
        'mnuExit
        '
        Me.mnuExit.Index = 5
        Me.mnuExit.Shortcut = System.Windows.Forms.Shortcut.CtrlQ
        Me.mnuExit.Text = "E&xit"
        '
        'mnuHelp
        '
        Me.mnuHelp.Index = 1
        Me.mnuHelp.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.mnuHelpAbout})
        Me.mnuHelp.Text = "&Help"
        '
        'mnuHelpAbout
        '
        Me.mnuHelpAbout.Index = 0
        Me.mnuHelpAbout.Text = "&About"
        '
        'txtDocument
        '
        Me.txtDocument.Anchor = CType((((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Bottom) _
                    Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.txtDocument.Location = New System.Drawing.Point(8, 0)
        Me.txtDocument.Multiline = True
        Me.txtDocument.Name = "txtDocument"
        Me.txtDocument.Size = New System.Drawing.Size(352, 280)
        Me.txtDocument.TabIndex = 0
        '
        'ofdOpenFile
        '
        Me.ofdOpenFile.Filter = "Text Files (*.txt)|*.txt"
        Me.ofdOpenFile.Title = "Open File"
        '
        'sfdSaveFile
        '
        Me.sfdSaveFile.Filter = "Text Files (*.txt)|*.txt"
        Me.sfdSaveFile.Title = "Save File As"
        '
        'frmMain
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(368, 286)
        Me.Controls.Add(Me.txtDocument)
        Me.Menu = Me.MainMenu1
        Me.Name = "frmMain"
        Me.Text = "Simple Text Editor"
        Me.ResumeLayout(False)
        Me.PerformLayout()

    End Sub

#End Region

    ' Class-level variables

    ' Holds the document file name
    Private strDocumentName As String = String.Empty

    ' isChanged equals True when the document has
    ' been changed since it was last saved. It holds
    ' false when the document has not been changed
    ' since it was last saved.

    Dim blnIsChanged As Boolean = False

    Private Sub mnuFileNew_Click(ByVal sender As System.Object, _
        ByVal e As System.EventArgs) Handles mnuFileNew.Click

        ' Begin a new document.
        If blnIsChanged = True Then
            ' Document has been changed and is not saved
			If MessageBox.Show("The current document is not saved. " & _
				 "Are you sure?", "Confirm", MessageBoxButtons.YesNo) _
				 = Windows.Forms.DialogResult.Yes Then
				ClearDocument()
			End If
        Else
            ' Document has not changed
            ClearDocument()
        End If
    End Sub

    Private Sub mnuFileOpen_Click(ByVal sender As System.Object, _
        ByVal e As System.EventArgs) Handles mnuFileOpen.Click

        ' Open an existing text file.
        If blnIsChanged = True Then
            ' Document has been changed and is not saved
            If MessageBox.Show("The current document is not saved. " & _
                 "Are you sure?", "Confirm", MessageBoxButtons.YesNo) _
                 = Windows.Forms.DialogResult.Yes Then
                ClearDocument()
                OpenDocument()
            End If
        Else
            ' Document has not changed
            ClearDocument()
            OpenDocument()
        End If
    End Sub

    Private Sub mnuFileSave_Click(ByVal sender As System.Object, _
        ByVal e As System.EventArgs) Handles mnuFileSave.Click

        ' Save the current document under its existing name.
        If strDocumentName = String.Empty Then
            ' The document has not been saved, so 
            ' use Save As dialog box.
			If sfdSaveFile.ShowDialog = Windows.Forms.DialogResult.OK Then
				strDocumentName = sfdSaveFile.FileName
				SaveDocument()
			End If
        Else
            SaveDocument()
        End If
    End Sub

    Private Sub mnuFileSaveAs_Click(ByVal sender As System.Object, _
        ByVal e As System.EventArgs) Handles mnuFileSaveAs.Click

        ' Save the current document under a new name.
		If sfdSaveFile.ShowDialog = Windows.Forms.DialogResult.OK Then
			strDocumentName = sfdSaveFile.FileName
			SaveDocument()
		End If
    End Sub

    Private Sub mnuExit_Click(ByVal sender As System.Object, _
    ByVal e As System.EventArgs) Handles mnuExit.Click

        ' End the application with the Close method so the 
        ' Closing event will trigger.
        Me.Close()
    End Sub

    Private Sub mnuHelpAbout_Click(ByVal sender As System.Object, _
        ByVal e As System.EventArgs) Handles mnuHelpAbout.Click

        ' Display an about box.
        MessageBox.Show("Simple Text Editor version 1.0")
    End Sub

    Sub ClearDocument()
        ' Clear the contents of the text box.
        txtDocument.Clear()
        ' Clear the document name.
        strDocumentName = String.Empty
        ' Set isChanged to False.
        blnIsChanged = False
    End Sub

    Sub OpenDocument()
        ' Use the OpenFileDialog control to get
        ' a file name.
        Dim inputFile As StreamReader

		If ofdOpenFile.ShowDialog = Windows.Forms.DialogResult.OK Then
			strDocumentName = ofdOpenFile.FileName
			inputFile = File.OpenText(strDocumentName)
			txtDocument.Text = inputFile.ReadToEnd
			inputFile.Close()
		End If
    End Sub

    Sub SaveDocument()
        ' Save the current document under the name
        ' stored in strDocumentName.
        Dim outputFile As StreamWriter

        outputFile = File.CreateText(strDocumentName)
        outputFile.Write(txtDocument.Text)
        outputFile.Close()
        ' Update the isChanged variable.
        blnIsChanged = False
    End Sub

    Sub SaveAs()
		If sfdSaveFile.ShowDialog = Windows.Forms.DialogResult.OK Then
			strDocumentName = sfdSaveFile.FileName
			SaveDocument()
		End If

    End Sub

    Private Sub txtDocument_TextChanged(ByVal sender As Object, _
        ByVal e As System.EventArgs) Handles txtDocument.TextChanged

        ' Update the isChanged variable to indicate that
        ' the text has changed.
        blnIsChanged = True
    End Sub

    Private Sub frmMain_FormClosing(ByVal sender As Object, _
        ByVal e As System.Windows.Forms.FormClosingEventArgs) _
        Handles Me.FormClosing

        ' If the document has not been changed, confirm 
        ' before exiting.
        If blnIsChanged = True Then
			If MessageBox.Show("The current document is not saved. " & _
			  "Do you wish to discard your changes?", "Confirm", _
			  MessageBoxButtons.YesNo) = Windows.Forms. _
			  DialogResult.Yes Then
				e.Cancel = False
			Else
				e.Cancel = True
			End If
        End If
    End Sub
End Class
